rules:
  - id: glappsec_insecure-url-parsing-1
    languages: 
      - ruby
    mode: taint
    pattern-sources:
      - patterns:
          - pattern: |
              def $F(...,$ARG,...)
                  ...
                  $MODULE.parse(..., $ARG, ...)
                  ...
              end
          - focus-metavariable: $ARG
          - metavariable-regex:
              metavariable: $MODULE
              regex: ^(Addressable::URI|URI)$
      - pattern: params
    pattern-sinks:
      - pattern: Net::HTTP::$METHOD(...)
    message: >
      Detected HTTP request after insecure parsing of URL. 
      Please use Gitlab::HTTP to make outbound HTTP requests as it includes protection against Server-Side Request Forgery (SSRF) vulnerabilities. 
      Refer to https://docs.gitlab.com/ee/development/secure_coding_guidelines.html#server-side-request-forgery-ssrf for more information.
    metadata:
      vulnerability_class: "Server side request forgery"
      technology:
        - ruby
        - rails
      confidence: HIGH
    severity: WARNING
